Foxit PDF SDK

Instance Methods | List of all members
FSPDFNumberTree Class Reference
Inheritance diagram for FSPDFNumberTree:

## Instance Methods
(FSPDFObject *) | - getObj:
| Get the value (as PDF object) of a specified key integer. More...
(FSPDFNumberTreeType) | - getType
| Get the type of current number tree. More...
(BOOL) | - hasNumber:
| Check if the specified key integer exists in current number tree. More...
(id) | - init
| Constructor.
(id) | - initWithDocument:type:
| Constructor, with parameters. More...
(id) | - initWithOther:
| Constructor, with another PDF number tree object. More...
(BOOL) | - isEmpty
| Check whether current object is empty or not. More...
(BOOL) | - removeAllObjs
| Remove all key integers from current number tree, along with theirs value (as PDF object). More...
(BOOL) | - removeObj:
| Remove a key integer from current number tree, along with its value (as PDF object). More...
(BOOL) | - setObj:pdf_object:
| Set the value (as PDF object) of a specified key integer. If the key integer does not exist, it will be added to current number tree with the value. More...

## Detailed Description

Number tree is a kind of common data structure in PDF. A number tree is similar to a number tree, except that keys in a number tree are integers instead of strings and are sorted in ascending numerical order. Number tree has following characteristics:

- key integers in a number tree are sorted in ascending numerical order and each key integer in the same number tree is unique;
- values associated with the key integers may be objects of any type, depending on the purpose of the number tree;
- number tree can represent an arbitrarily large collection of key-value pairs, which can be looked up efficiently without requiring the entire data structure to be read from the PDF file.

Class FSPDFNumberTree is used to be associated with an existing number tree with specified type or create one. It offers functions to get key-value pairs in the number tree, and set/add/remove any key-value pair. Currently, class FSPDFNumberTree can be associated with following number tree defined in PDF document:

- Page labels number tree (with type FSPDFNumberTreePageLabels), which defines the page labeling for the document. The keys in this tree are page indexes; the corresponding values are page label dictionaries (Please refer to <PDF Renferece 1.7> P594 Section 8.3.1, "Page Labels"). Each page index denotes the first page in a labeling range to which the specified page label dictionary applies. The tree must include a value for page index 0.

## Method Documentation

## ◆ getObj:()

- (FSPDFObject *) getObj: |  | (int) | number |

Get the value (as PDF object) of a specified key integer.

Parameters

  [in] | number | An integer as the key.

Returns
  A FSPDFObject object. The type of returned PDF object depends on the purpose of current number tree. Please refer to comment of class FSPDFNumberTree for more details. If not found, this function will return nil.

## ◆ getType()

- (FSPDFNumberTreeType) getType |  |  |

Get the type of current number tree.

Returns
  Type of current number tree. Please refer to values starting from FSPDFNumberTreePageLabels and this would be one of these values.

## ◆ hasNumber:()

- (BOOL) hasNumber: |  | (int) | number |

Check if the specified key integer exists in current number tree.

Parameters

  [in] | number | An integer that represents the key to be checked.

Returns
  YES means the specified integer exists in current number tree, and NO means the specified integer does not exist in current number tree.

## ◆ initWithDocument:type:()

- (id) initWithDocument: |  | (FSPDFDoc*) | document
type: |  | (FSPDFNumberTreeType) | type

Constructor, with parameters.

If there exists number tree with specified type in the PDF document, this function is just to construct a PDF number tree object to be associated with the number tree. If there is no such number tree in PDF document, the constructed PDF number tree object can be used to create such number tree in PDF document and add items to the number tree.

Parameters

  [in] | document | A valid PDF document object.
  [in] | type | The type of the number tree. Please refer to values starting from FSPDFNumberTreePageLabels and this should be one of these values.

## ◆ initWithOther:()

- (id) initWithOther: |  | (FSPDFNumberTree*) | other |

Constructor, with another PDF number tree object.

Parameters

  [in] | other | Another PDF number tree object.

## ◆ isEmpty()

- (BOOL) isEmpty |  |  |

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  YES means current object is empty, while NO means not.

## ◆ removeAllObjs()

- (BOOL) removeAllObjs |  |  |

Remove all key integers from current number tree, along with theirs value (as PDF object).

Returns
  YES means success, while NO means failure.

## ◆ removeObj:()

- (BOOL) removeObj: |  | (int) | number |

Remove a key integer from current number tree, along with its value (as PDF object).

If the input key integer does not exist in current number tree, this function will return YES directly.

Parameters

  [in] | number | An integer as the key to be removed.

Returns
  YES means success, while NO means failure.

## ◆ setObj:pdf_object:()

- (BOOL) setObj: |  | (int) | number
pdf_object: |  | (FSPDFObject*) | pdf_object

Set the value (as PDF object) of a specified key integer. If the key integer does not exist, it will be added to current number tree with the value.

Parameters

  [in] | number | An integer as the key.
  [in] | pdf_object | A PDF object to be set as the key's value. It should not be nil. The type of this PDF object should match current number tree; otherwise, the input PDF object is invalid. Please refer to comment of class FSPDFNumberTree for more details. User should not release this PDF object after this function succeeds.

Returns
  YES means success, while NO means failure.